<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: banner-delete.php 1235 2005-01-17 16:36:51Z andrew $
*/

// Include required files
require ("config.php");
require ("lib-storage.inc.php");
require ("lib-zones.inc.php");
require ("lib-statistics.inc.php");
require ("../libraries/lib-priority.inc.php");

// Register input variables
phpAds_registerGlobal ('returnurl');

// Security check
phpAds_checkAccess(phpAds_Admin + phpAds_Agency);

if (phpAds_isUser(phpAds_Agency)) {
    $query = "
        SELECT
            b.bannerid AS bannerid
        FROM
            {$phpAds_config['tbl_clients']} AS cl,
            {$phpAds_config['tbl_campaigns']} AS ca,
            {$phpAds_config['tbl_banners']} AS b
        WHERE
            ca.clientid = $clientid
            AND b.campaignid = $campaignid
            AND b.bannerid = $bannerid
            AND b.campaignid = ca.campaignid
            AND ca.clientid = cl.clientid
            AND cl.agencyid = phpAds_getUserID()
        ";
    $res = phpAds_dbQuery($query) or phpAds_sqlDie();
    if (phpAds_dbNumRows($res) == 0) {
        phpAds_PageHeader("2");
        phpAds_Die ($strAccessDenied, $strNotAdmin);
    }
}

/*-------------------------------------------------------*/
/* Main code                                             */
/*-------------------------------------------------------*/

function phpAds_DeleteBanner($bannerid)
{
	global $phpAds_config;
	
	// Cleanup webserver stored image
    $query = "
        SELECT
            storagetype, filename
        FROM
            {$phpAds_config['tbl_banners']}
        WHERE
            bannerid = '$bannerid'
    ";
    $res = phpAds_dbQuery($query) or phpAds_sqlDie();
	
	if ($row = phpAds_dbFetchArray($res))
	{
		if (($row['storagetype'] == 'web' || $row['storagetype'] == 'sql') && $row['filename'] != '')
			phpAds_ImageDelete ($row['storagetype'], $row['filename']);
	}
	
	// Delete banner
    $query = "
        DELETE FROM
            {$phpAds_config['tbl_banners']}
        WHERE
            bannerid = '$bannerid'
        ";
    $res = phpAds_dbQuery($query) or phpAds_sqlDie();
	
	// Delete banner ACLs
    $query = "
        DELETE FROM
            {$phpAds_config['tbl_acls']}
        WHERE
            bannerid = '$bannerid'
        ";
    $res = phpAds_dbQuery($query) or phpAds_sqlDie();
	
    // Delete Ad_Zone Associations
    phpAds_dbQuery("DELETE FROM {$phpAds_config['tbl_ad_zone_assoc']} WHERE ad_id=$bannerid");
	        
 	// Delete statistics for this banner
	phpAds_deleteStatsByBannerID($bannerid);
}

if (isset($bannerid) && $bannerid != '') {
    phpAds_DeleteBanner($bannerid);
} else if (isset($campaignid) && $campaignid != '') {
    $query = "
        SELECT
            bannerid
        FROM
            ".$phpAds_config['tbl_banners']."
        WHERE
            campaignid = '$campaignid'
    ";
    $res = phpAds_dbQuery($query);
    while ($row = phpAds_dbFetchArray($res)) {
        phpAds_DeleteBanner($row['bannerid']);
    }
}

// Rebuild priorities
phpAds_PriorityCalculate();

// Rebuild cache
if (!defined('LIBVIEWCACHE_INCLUDED')) {
    include (phpAds_path.'/libraries/deliverycache/cache-'.$phpAds_config['delivery_caching'].'.inc.php');
}

phpAds_cacheDelete();

if (!isset($returnurl) && $returnurl == '') {
    $returnurl = 'campaign-banners.php';
}

header("Location: ".$returnurl."?clientid=".$clientid."&campaignid=".$campaignid);

?>