<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Dal.php 1239 2005-01-17 17:39:11Z andrew $
*/

/**
 * @package    MaxDal
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once maintenancePath . '/maintenance-common.php';

/**
 * The base Max Database Data Access Layer class.
 */
class Dal
{
    var $conf;
    var $dbConnection;
    
    /**
     * The constructor method - connects to the database.
     */
    function Dal()
    {
        $this->conf =& $GLOBALS['_MAX']['CONF'];
        static $connection;
        if (!isset($connection)) {
            $connection = mysql_connect("{$this->conf['db']['host']}:{$this->conf['db']['port']}", 
                $this->conf['db']['username'], $this->conf['db']['password']);
            if (!$connection) {
                debug('Error connecting to the database.', PEAR_LOG_ERR);
                debug('Aborting script execution', PEAR_LOG_ERR);
                exit();
            }
            if (!mysql_select_db($this->conf['db']['name'], $connection)) {
                debug('Error selecting database: ' . mysql_error($this->dbConnection), PEAR_LOG_ERR);
                debug('Aborting script execution', PEAR_LOG_ERR);
                exit();
            }
        }
        $this->dbConnection = $connection;
    }
    
    /**
     * The singleton method to create or return a single instance of the class.
     *
     * @static
     * @return Dal The returned Dal object.
     */
    function &singleton() {
        static $instance;
        if (!isset($instance)) {
            $instance = new Dal();
        }
        return $instance;
    }
    
    /**
     * A method for executing SQL statements.
     *
     * Aborts execution of the entire PHP script if the SQL statement
     * results in an error from MySQL.
     *
     * @param text $sql The SQL statement to execute.
     * @param resource $result A reference to the MySQL result resouce.
     */
    function execute($sql, &$result) {
        $result = @mysql_query($sql, $this->dbConnection);
        if (!$result) {
            debug('Error executing SQL: ' . $sql . ': ' . mysql_error($this->dbConnection), PEAR_LOG_ERR);
            debug('Aborting script execution', PEAR_LOG_ERR);
            exit();
        }
    }
    
    /**
     * A method for executing SQL statements that might cause non-fatal
     * errors.
     *
     * Aborts execution of the entire PHP script if the SQL statement
     * results in an error from MySQL, unless the MySQL error code
     * is found in the array of supplied error codes.
     *
     * @param text $sql The SQL statement to execute.
     * @param resource $result A reference to the MySQL result resouce.
     * @param array $error An array of integer MySQL error codes that
     *                     will be ignored (ie. won't halt the execution
     *                     of the PHP script).
     * @return integer The error number ignored, if executed with errors, or 0 if
     *                 there were no errors.
     */
    function executeIgnoreErrors($sql, &$result, $errors) {
        $returnValue = 0;
        $result = @mysql_query($sql, $this->dbConnection);
        if (!$result) {
            // Is the MySQL error code permitted to be ignored?
            $returnedError = mysql_errno($this->dbConnection);
            $halt = true;
            foreach ($errors as $errorCode) {
                if ($returnedError == $errorCode) {
                    $halt = false;
                    $returnValue = $errorCode;
                    break;
                }
            }
            if ($halt) {
                // Did not find the error was safe to ignore, so abort
                debug('Error executing SQL: ' . $sql . ': ' . mysql_error($this->dbConnection), PEAR_LOG_ERR);
                debug('Aborting script execution', PEAR_LOG_ERR);
                exit();
            } else {
                // The error may be safely ignored
                debug('Safely ignored MySQL error code ' . $returnedError, PEAR_LOG_DEBUG);
            }
        }
        return $returnValue;
    }
    
    /**
     * A method for fetching the number of rows returned by a SQL statement.
     *
     * @param resource result $result A MySQL resource result.
     */
    function numberOfRows(&$result)
    {
        return mysql_num_rows($result);
    }
    
    /**
     * A method for fetching the data returned by a SQL statement into an array.
     *
     * @param resource result $result A MySQL resource result.
     */
    function fetchResultAsArray(&$result)
    {
        $array = array();
        $array = mysql_fetch_array($result);
        return $array;
    }
    
    /**
     * A method for returning the number of rows affected by a SQL statement
     * executed (immediately) previously.
     */
    function affectedRows()
    {
        return mysql_affected_rows($this->dbConnection);
    }
       
}

?>
