<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: all_tests.php 1238 2005-01-17 17:28:53Z andrew $
*/

/**
 * @package    Max
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

/**
 * A script for running all tests in the project.
 */

// Configure the installation paths
define('TEST_PATH', dirname(__FILE__));
define('MAX_PATH', preg_replace('#/tests#', '', TEST_PATH));

// Include the simpletest classes, if required
require_once MAX_PATH . '/libraries/pear/simpletest/unit_tester.php';
require_once MAX_PATH . '/libraries/pear/simpletest/reporter.php';

// Output the HTML header
include MAX_PATH . '/tests/header.html';

// Record the test start time
$testStart = time();

// Run the Delivery Engine tests
require MAX_PATH . '/tests/delivery/all_tests.php';

// Run the Maintenance Engine tests
require MAX_PATH . '/maintenance/libraries/max/Dal/tests/all_tests.php';
require MAX_PATH . '/maintenance/libraries/max/Maintenance/tests/all_tests.php';

// Calculate and display the test run time
$testEnd = time();
$time = $testEnd - $testStart;
echo '<p>Tests took ' . $time . ' seconds</p>';

// Output the HTML footer
include MAX_PATH . '/tests/footer.html';

?>
